import {select ,csv,scaleLinear,max ,scaleBand,axisLeft, axisBottom ,format} from 'd3';

const svg = d3.select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data =>{
  const xValue = d=>d.Count;
  const yValue = d=>d.SalaryRange;
  const margin = {top:30, right:40 , bottom:20 , left:160};
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  const xScale = scaleLinear()
  	.domain([0,max(data,xValue)])
  	.range([0,innerWidth]);
  
  const yScale = scaleBand()
  	.domain(data.map(yValue))
  	.range([0,innerHeight])
  	.padding(0.1); 
  
  
  const g = svg.append('g')
  	.attr('transform' ,`translate(${margin.left},${margin.top})`);
    
  const xAxis = axisBottom(xScale)
  	.tickSize(-innerHeight);
  
  g.append('g')
    .call(axisLeft(yScale))
  	.selectAll('.domain,.tick line')
  		.remove();
	
  const xAxisG = g.append('g').call(xAxis)
  	.attr('transform' ,`translate(0,${innerHeight})`);
 
	xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
  		.attr('class','axisLabel')
    	.attr('x',innerWidth/2)
  		.attr('y',55)
  		.attr('fill','black')
  		.text('Count');

  g.selectAll('rect').data(data)
  	.enter().append('rect')
  		.attr('y',d=>yScale(yValue(d)))
 	 		.attr('width' ,d=>xScale(xValue(d)))
  		.attr('height' ,yScale.bandwidth());

	g.append('text')
  	.attr('class','title')
  	.attr('y',-10)
  	.text('Salary Analysis');

};
csv('data.csv').then(data => {
  data.forEach(d=>{
    d.Count =+d.Count;
  });
	render(data);
});